/**
 * \file
 *
 * \brief DALIMޯĂ̕ƕ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "compiler.h"
#include "dali_bit.h"
#include "dali_top.h"
#include "pcint.h"

#define BIT_START				0xFF
#define BIT_0					0x01
#define BIT_1					0x02
#define BIT_2					0x03
#define BIT_3					0x04
#define BIT_4					0x05
#define BIT_5					0x06
#define BIT_6					0x07
#define BIT_7					0x08
#define BIT_8					0x09
#define BIT_9					0x0A
#define BIT_10					0x0B
#define BIT_11					0x0C
#define BIT_12					0x0D
#define BIT_13					0x0E
#define BIT_14					0x0F
#define BIT_15					0x10
#define BIT_STOP1				0x11
#define BIT_STOP2				0x12

#define MIN_TE_CNT				(NOR_TE_CNT - 5)
#define MAX_TE_CNT				(NOR_TE_CNT + 5)

#define MIN_2TE_CNT				(2 * MIN_TE_CNT)
#define MAX_2TE_CNT				(2 * MAX_TE_CNT)
#define STOP_CNT				(4 * NOR_TE_CNT)
/* 500ms */
#define FAIL_TIME				(1200 * NOR_TE_CNT)

/* DALIo */
#define DALI_OUTPORT			PORTB
#define DALI_TOGGLE_OUTPORT		PINB
#define DALI_OUTPUT				PORTB1

/* PWMo */
#define PWM_OUTPUT				PORTB2

/* DALI */
#define DALI_INPORT				PINC
#define DALI_INPUT				PC2

#define LOW						0

volatile uint8_t level_time;
volatile uint8_t status_receive;
volatile uint8_t pin_level;
volatile uint16_t interface_fail_time = 0;
volatile uint8_t dali_rec_addr, dali_rec_data;
volatile uint8_t send_status, interface_fail_flag = 0;
volatile uint8_t dali_send_data;

void dali_bit_pcint_interrupt(void);

void dali_bit_init(void)
{
	/* I/O߰ď */
	DDRB = (1 << DALI_OUTPUT) | (1 << PWM_OUTPUT);
	/* DALIHighdɐݒ */
	DALI_OUTPORT |= (1 << DALI_OUTPUT);
	pin_level = DALI_INPORT & (1 << DALI_INPUT);

	/* PCINT10DALI */
	pcint_set_pin_change(PCINT_PIN_14_8, PCINT10, PCINT_ENABLE);
	pcint_set_interrupt(PCINT_PCIE_PIN_14_8, PCINT_ENABLE);
	pcint_interrupt_callback(PCINT_PCIE_PIN_14_8, dali_bit_pcint_interrupt);
}

/**
 * \brief O݊荞ݏ
 *
 * ͊O݊荞ݏłB
 */
void dali_bit_pcint_interrupt(void)
{
	static uint8_t bit_index;
	uint8_t bit_index_temp;
	uint8_t dali_bit_rx;

	bit_index_temp = bit_index;
	pin_level = DALI_INPORT & (1 << DALI_INPUT);

	if (status_receive == 0) {
		if (pin_level == LOW) {
			/* DALI޽~[͊JnޯĂ܂B */
			bit_index_temp = 0;
			status_receive = BIT_START;
			dali_rec_addr = 0;
			dali_rec_data = 0;
		}
	} else if (status_receive == BIT_START) {
		/* DALI݂2ڂINT0[HighłȂ΂Ȃ܂B */
		if ((level_time > MIN_TE_CNT) && (level_time < MAX_TE_CNT)) {
			/* JnޯĎ擾16ޯ ްp */
			status_receive = BIT_0;
			bit_index_temp += 1;
		} else {
			/* JnޯĈُ */
			status_receive = 0;
		}
	} else if (status_receive < BIT_STOP1) {
		if (level_time > MIN_2TE_CNT) {
			/* (2~Te)o */
			bit_index_temp += 2;
		} else if ((level_time > MIN_TE_CNT) &&
				(level_time < MAX_TE_CNT)) {
			/* Z(1~Te)o */
			bit_index_temp += 1;
		} else {
			status_receive = 0;
		}

		if (bit_index_temp >= 34) {
			/* ŌTeLow(DALI0ޯ)ȂA~ޯđOɏ㏸[o܂B */
			status_receive = BIT_STOP1;
		}

		/* ̑2TeޯĂDALIޯĂ𕜍 */
		if (bit_index_temp & 0x01) {
			/* DALIޯĂ𓾂邽߂ɍŉޯĂړ */
			dali_bit_rx = bit_index_temp >> 1;
			if (dali_bit_rx <= BIT_7) {
				/* ڽ ޲Ď擾 */
				dali_rec_addr <<= 1;
				if (pin_level) {
					dali_rec_addr |= 0x01;
				}
			} else {
				/* ް ޲Ď擾 */
				dali_rec_data <<= 1;
				if (pin_level) {
					dali_rec_data |= 0x01;
					if (dali_bit_rx == BIT_15) {
						/* ŌTeHigh(DALI1ޯ)ȂA~ޯđOTeHighԂǉ܂B */
						status_receive = BIT_STOP2;
					}
				}
			}
		}
	} else {
		status_receive = 0;
	}

	dali_slave_set_addr_to_service(dali_rec_addr);
	dali_slave_set_data_to_service(dali_rec_data);
	bit_index = bit_index_temp;
	TCNT0 = 0;
	level_time = 0;
}

void dali_bit_timer_interrupt(void)
{
	static uint8_t dali_bit_index;
	static uint8_t bit_length;
	uint8_t dali_bit_tx;
	uint8_t bit_length_temp;
	dali_slave_frame_time_inc();
	send_status = dali_slave_get_send_status_from_service();
	dali_send_data = dali_slave_get_send_data_from_service();
	if (pin_level == LOW) {
		if (interface_fail_time == FAIL_TIME) {
			dali_slave_set_fail_flag_to_service(1);
			interface_fail_time++;
		} else if (interface_fail_time < FAIL_TIME) {
			interface_fail_time++;
		}
	} else {
		interface_fail_time = 0;
	}

	if (status_receive) {
		level_time++;
		if (status_receive == BIT_STOP2) {
			if (DALI_INPORT & (1 << DALI_INPUT)) {
				if (level_time > (STOP_CNT + NOR_TE_CNT)) {
					/* ~ޯ */
					status_receive = 0;
					/* Receive complete */
					dali_slave_set_frame_flag_to_service(true);
				}
			} else {
				/* DALI݂LowȂA~ޯĈُ */
				status_receive = 0;
			}
		} else if (status_receive == BIT_STOP1) {
			if (DALI_INPORT & (1 << DALI_INPUT)) {
				if (level_time > STOP_CNT) {
					/* ~ޯ */
					status_receive = 0;
					/* M */
					dali_slave_set_frame_flag_to_service(true);
				}
			} else {
				/* DALI݂LowȂA~ޯĈُ */
				status_receive = 0;
			}
		} else {
			if (level_time > MAX_2TE_CNT) {
				/* ُ */
				status_receive = 0;
			}
		}
	} else if (send_status) {
		/* DALItڰёo */
		dali_bit_tx = dali_bit_index;
		bit_length_temp = bit_length;
		bit_length_temp++;
		if (send_status != BIT_STOP1) {
			/* tް ޲ */
			if (dali_bit_tx == 0) {
				/* Jnޯ */
				if (bit_length_temp == 1) {
					DALI_OUTPORT &= ~(1 << DALI_OUTPUT);
				} else if (bit_length_temp == (NOR_TE_CNT + 1)) {
					DALI_TOGGLE_OUTPORT |= (1 << DALI_OUTPUT);
				}
			} else if (dali_send_data & (1 << (BIT_7 - dali_bit_tx))) {
				/* DALI1ޯ */
				if (bit_length_temp == 1) {
					DALI_OUTPORT &= ~(1 << DALI_OUTPUT);
				} else if (bit_length_temp == (NOR_TE_CNT + 1)) {
					DALI_TOGGLE_OUTPORT |= (1 << DALI_OUTPUT);
				}
			} else {
				/* DALI0ޯ */
				if (bit_length_temp == 1) {
					DALI_OUTPORT |= (1 << DALI_OUTPUT);
				} else if (bit_length_temp == (NOR_TE_CNT + 1)) {
					DALI_TOGGLE_OUTPORT |= (1 << DALI_OUTPUT);
				}
			}

			if (bit_length_temp == (2 * NOR_TE_CNT)) {
				dali_bit_tx++;
				if (dali_bit_tx > BIT_7) {
					send_status = BIT_STOP1;
					dali_bit_tx = 0;
				}

				bit_length_temp = 0;
			}
		} else {
			/* ~ޯ */
			if (bit_length_temp < (4 * NOR_TE_CNT)) {
				DALI_OUTPORT |= (1 << DALI_OUTPUT);
			} else {
				/* M */
				send_status = 0;
				bit_length_temp = 0;
			}
		}
		dali_slave_set_send_status_to_service(send_status);
		bit_length = bit_length_temp;
		dali_bit_index = dali_bit_tx;
	}
}
