/**
 * \file
 *
 * \brief PCINTײ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "compiler.h"
#include "pcint.h"
static pcint_callback_t pcint0_callback;
static pcint_callback_t pcint1_callback;
static pcint_callback_t pcint2_callback;

void pcint_set_pin_change(enum pcint_module_t pcmsk, uint8_t pin, enum pcint_set_t set)
{
	if (pcmsk == PCINT_PIN_7_0) {
		if (set == PCINT_DISABLE) {
			PCMSK0 &= ~(1 << pin);
		} else {
			PCMSK0 |= (1 << pin);
		}
	} else if (pcmsk == PCINT_PIN_14_8) {
		if (set == PCINT_DISABLE) {
			PCMSK1 &= ~(1 << pin);
		} else {
			PCMSK1 |= (1 << pin);
		}
	} else if (pcmsk == PCINT_PIN_23_16) {
		if (set == PCINT_DISABLE) {
			PCMSK2 &= ~(1 << pin);
		} else {
			PCMSK2 |= (1 << pin);
		}
	}
}

void pcint_set_interrupt(enum pcint_pcie_t pcie, enum pcint_set_t set)
{
	if (set == PCINT_DISABLE) {
		PCICR &= ~(1 << pcie);
	} else {
		PCICR |= (1 << pcie);
	}
}

ISR(PCINT0_vect)
{
	if (pcint0_callback) {
		pcint0_callback();
	}
}

ISR(PCINT1_vect)
{
	if (pcint1_callback) {
		pcint1_callback();
	}
}

ISR(PCINT2_vect)
{
	if (pcint2_callback) {
		pcint2_callback();
	}
}

void pcint_interrupt_callback(enum pcint_module_t pcint,
		pcint_callback_t callback)
{
	if (pcint == PCINT_PIN_7_0) {
		pcint0_callback = callback;
	} else if (pcint == PCINT_PIN_14_8) {
		pcint1_callback = callback;
	} else if (pcint == PCINT_PIN_23_16) {
		pcint2_callback = callback;
	}
}