/**
 * \file
 *
 * \brief TCײ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "compiler.h"
#include "tc.h"

static tc_callback_t tc0_ovf_callback;
static tc_callback_t tc1_ovf_callback;
static tc_callback_t tc2_ovf_callback;

void tc_write_clock_source(enum tc_module_t tc, enum tc_clkset_t cklsel)
{
	if (tc == TC0) {
		TCCR0B = (TCCR0B & ~TC_CLKSEL_gm) | cklsel;
	} else if (tc == TC1) {
		TCCR1B = (TCCR1B & ~TC_CLKSEL_gm) | cklsel;
	} else {
		TCCR2B = (TCCR2B & ~TC_CLKSEL_gm) | cklsel;
	}
}

void tc_write_count(enum tc_module_t tc, uint8_t cnt_low, uint8_t cnt_high)
{
	if (tc == TC0) {
		TCNT0 = cnt_low;
	} else if (tc == TC1) {
		TCNT1H = cnt_high;
		TCNT1L = cnt_low;
	} else {
		TCNT2 = cnt_low;
	}
}

uint16_t tc_read_count(enum tc_module_t tc)
{
	if (tc == TC0) {
		return TCNT0;
	} else if (tc == TC1) {
		return TCNT1;
	} else {
		return TCNT2;
	}
}

void tc1_set_wgm(enum tc1_wg_mode_t wgm)
{
	TCCR1B = TCCR1B & (~((1 << WGM13) | (1 << WGM12)));
	TCCR1A = TCCR1A & (~((1 << WGM11) | (1 << WGM10)));
	switch (wgm) {
	case TC1_WG_NORMAL:
		break;

	case TC1_WG_PWM_PHASE_CORRECT_8_BIT:
		TCCR1A |= 1 << WGM10;
		break;

	case TC1_WG_PWM_PHASE_CORRECT_9_BIT:
		TCCR1A |= 1 << WGM11;
		break;

	case TC1_WG_PWM_PHASE_CORRECT_10_BIT:
		TCCR1A |= (1 << WGM10) | (1 << WGM11);
		break;

	case TC1_WG_CTC_OCRA:
		TCCR1B |= 1 << WGM12;
		break;

	case TC1_WG_FAST_PWM_8_BIT:
		TCCR1B |= 1 << WGM12;
		TCCR1A |= 1 << WGM10;
		break;

	case TC1_WG_FAST_PWM_9_BIT:
		TCCR1B |= 1 << WGM12;
		TCCR1A |= 1 << WGM11;
		break;

	case TC1_WG_FAST_PWM_10_BIT:
		TCCR1B |= 1 << WGM12;
		TCCR1A |= (1 << WGM10) | (1 << WGM11);
		break;

	case TC1_WG_PWM_PHASE_AND_FREQUENCY_CORRECT_ICR:
		TCCR1B |= 1 << WGM13;
		break;

	case TC1_WG_PWM_PHASE_AND_FREQUENCY_CORRECT_OCRA:
		TCCR1B |= 1 << WGM13;
		TCCR1A |= 1 << WGM10;
		break;

	case TC1_WG_PWM_PHASE_CORRECT_ICR:
		TCCR1B |= 1 << WGM13;
		TCCR1A |= 1 << WGM11;
		break;

	case TC1_WG_PWM_PHASE_CORRECT_OCRA:
		TCCR1B |= 1 << WGM13;
		TCCR1A |= (1 << WGM11) | (1 << WGM10);
		break;

	case TC1_WG_CTC_ICR:
		TCCR1B |= (1 << WGM13) | (1 << WGM12);
		break;

	case TC1_WG_FAST_PWM_ICR:
		TCCR1B |= (1 << WGM13) | (1 << WGM12);
		TCCR1A |= 1 << WGM11;
		break;

	case TC1_WG_FAST_PWM_OCRA:
		TCCR1B |= (1 << WGM13) | (1 << WGM12);
		TCCR1A |= (1 << WGM11) | (1 << WGM10);
		break;

	default:
		break;
	}
}

void tc_set_interrupt(enum tc_module_t tc, enum tc_interrupt_t interrupt,
		enum tc_int_set_t set)
{
	if (tc == TC0) {
		if (set == TC_INT_DISABLE) {
			TIMSK0 &= ~(1 << interrupt);
		} else {
			TIMSK0 |= (1 << interrupt);
		}
	} else if (tc == TC1) {
		if (set == TC_INT_DISABLE) {
			TIMSK1 &= ~(1 << interrupt);
		} else {
			TIMSK1 |= (1 << interrupt);
		}
	} else if (tc == TC2) {
		if (set == TC_INT_DISABLE) {
			TIMSK2 &= ~(1 << interrupt);
		} else {
			TIMSK2 |= (1 << interrupt);
		}
	}
}

ISR(TIMER0_OVF_vect)
{
	if (tc0_ovf_callback) {
		tc0_ovf_callback();
	}
}

ISR(TIMER1_OVF_vect)
{
	if (tc1_ovf_callback) {
		tc1_ovf_callback();
	}
}

ISR(TIMER2_OVF_vect)
{
	if (tc2_ovf_callback) {
		tc2_ovf_callback();
	}
}

void tc_set_overflow_interrupt_callback(enum tc_module_t tc,
		tc_callback_t callback)
{
	if (tc == TC0) {
		tc0_ovf_callback = callback;
	} else if (tc == TC1) {
		tc1_ovf_callback = callback;
	} else if (tc == TC2) {
		tc2_ovf_callback = callback;
	}
}
